using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.Specialized;
using GameEngine;

namespace ConnectFour.WPF {
	public class DiscToBrushConverter : IValueConverter {
		#region IValueConverter Members

		object IValueConverter.Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
			if (targetType == typeof(string))
				return value.ToString( );
			if (targetType != typeof(Brush))
				throw new InvalidOperationException("Can only convert to brushes!");
			if (value == null)
				return null;
			DiscType discType = (DiscType) value;
			return discType == DiscType.Red ? Brushes.Red : Brushes.Yellow;
		}

		object IValueConverter.ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture) {
			throw new Exception("The method or operation is not implemented.");
		}

		#endregion
	}
}
