using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using System.Diagnostics;

namespace GameEngine.Tests {
	[TestFixture]
	public class ColumnTests {
		Grid grid;

		[SetUp]
		public void Setup( ) {
			grid = new Grid( );
		}

		[Test]
		public void AddDisc( ) {
			grid.Columns[0].AcceptDisc(DiscType.Red);
			Assert.AreEqual(1, grid.Columns[0].Discs.Count);
		}

		[Test]
		[ExpectedException(typeof(Exception), "The column is full.")]
		public void AddTooManyDiscs( ) {
			grid.RowCount = 2;
			grid.Columns[0].AcceptDisc(DiscType.Red);
			grid.Columns[0].AcceptDisc(DiscType.Red);
			Assert.AreEqual(2, grid.Columns[0].Discs.Count);
			grid.Columns[0].AcceptDisc(DiscType.Red);
		}

	}
}
