using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;

namespace GameEngine.Tests {
	[TestFixture]
	public class DiscSequenceCounterTests {
		[Test]
		public void Test1( ) {
			DiscSequenceCounter discSequenceCounter = new DiscSequenceCounter( );
			discSequenceCounter.AcceptDisc(DiscType.Red);
			Assert.AreEqual(DiscType.Red, discSequenceCounter.BestSequence);
			Assert.AreEqual(1, discSequenceCounter.BestSequenceLength);
			discSequenceCounter.AcceptDisc(DiscType.Red);
			discSequenceCounter.AcceptDisc(DiscType.Red);
			Assert.AreEqual(DiscType.Red, discSequenceCounter.BestSequence);
			Assert.AreEqual(3, discSequenceCounter.BestSequenceLength);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			Assert.AreEqual(DiscType.Red, discSequenceCounter.BestSequence);
			Assert.AreEqual(3, discSequenceCounter.BestSequenceLength);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			Assert.AreEqual(DiscType.Yellow, discSequenceCounter.BestSequence);
			Assert.AreEqual(4, discSequenceCounter.BestSequenceLength);
		}

		[Test]
		public void ResetSequence( ) {
			DiscSequenceCounter discSequenceCounter = new DiscSequenceCounter( );
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			discSequenceCounter.ResetSequence( );
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			discSequenceCounter.AcceptDisc(DiscType.Yellow);
			Assert.AreEqual(2, discSequenceCounter.BestSequenceLength);
		}
	}
}
