using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;

namespace GameEngine {
	public class Column {
		public Column(Grid grid) {
			this.grid = grid;
			discs = new BindingList<DiscType>( );
		}

		private Grid grid;
		public Grid Grid {
			get {
				return grid;
			}
		}

		private BindingList<DiscType> discs;
		public BindingList<DiscType> Discs {
			get {
				return discs;
			}
		}

		public bool IsFull {
			get {
				return discs.Count >= grid.RowCount;
			}
		}

		public void AcceptDisc(DiscType discType) {
			if (IsFull)
				throw new Exception("The column is full.");
			discs.Add(discType);
		}

		public DiscType? FindWinner( ) {
			DiscSequenceCounter sequenceCounter = new DiscSequenceCounter( );
			foreach (DiscType discType in Discs)
				sequenceCounter.AcceptDisc(discType);

			return sequenceCounter.BestSequenceLength >= grid.SequenceLengthForWin ? 
				sequenceCounter.BestSequence : null;
		}
	}
}