using System;
using System.Collections.Generic;
using System.Text;

namespace GameEngine {
	public class DiscSequenceCounter {
		DiscType? bestSequence = null;
		public DiscType? BestSequence {
			get {
				return bestSequence;
			}
		}

		int bestSequenceLength = 0;
		public int BestSequenceLength {
			get {
				return bestSequenceLength;
			}
		}

		DiscType? currentSequence = null;
		int currentSequenceLength = 0;

		private void CalcBestSequence( ) {
			if (currentSequenceLength > bestSequenceLength) {
				bestSequence = currentSequence;
				bestSequenceLength = currentSequenceLength;
			}
		}

		public void AcceptDisc(DiscType discType) {
			if (currentSequence != discType) {
				CalcBestSequence( );
				currentSequence = discType;
				currentSequenceLength = 1;
			}
			else
				currentSequenceLength++;

			CalcBestSequence( );
		}

		public void ResetSequence( ) {
			currentSequence = null;
			currentSequenceLength = 0;
		}
	}
}
