using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Windows;

namespace WPFHelpers {
	public class IntSequence : DependencyObject, IEnumerable<int> {
		public static readonly DependencyProperty StartValProperty;
		public static readonly DependencyProperty EndValProperty;

		static IntSequence( ) {
			StartValProperty = DependencyProperty.Register("StartVal",
				typeof(int), typeof(IntSequence), new PropertyMetadata(1));
			EndValProperty = DependencyProperty.Register("EndVal",
				typeof(int), typeof(IntSequence), new PropertyMetadata(10));
		}

		public int StartVal {
			get { return (int) GetValue(StartValProperty); }
			set { SetValue(StartValProperty, value); }
		}

		public int EndVal {
			get { return (int) GetValue(EndValProperty); }
			set { SetValue(EndValProperty, value); }
		}

		#region IEnumerable<int> Members

		IEnumerator<int> IEnumerable<int>.GetEnumerator( ) {
			for (int val = StartVal; val <= EndVal; val++)
				yield return val;
		}

		#endregion

		#region IEnumerable Members

		IEnumerator IEnumerable.GetEnumerator( ) {
			foreach (int item in this)
				yield return item;
		}

		#endregion
	}
}
